# Expression types
E_BOOLEAN = 1
E_INT = 2
E_FLOAT = 3
E_STRING = 4
E_FILENAME = 5
E_DATETIME = 6

E_STRING_FILENAME_DATETIME = 20

class FSLError(Exception):
    def __init__(self, msg):
        Exception.__init__(self, msg)

class FSLParseError(FSLError):
    def __init__(self, token, msg):
        """token is `lexer.Token` instance, msg is error message."""
        FSLError.__init__(self, msg)
        self.token = token
        self.msg = msg

    def __str__(self):
        if self.token:
            return 'Parse error (L %d): %s (token: "%s")' % (self.token.lineno, self.msg, self.token.strvalue)
        else:
            return 'Parse error: %s' % self.msg

class FSLSyntaxError(FSLError):
    def __init__(self, token, msg):
        FSLError.__init__(self, msg)
        self.token = token
        self.msg = msg

    def __str__(self):
        if self.token:
            return 'Syntax error (L %d): %s (token: "%s")' % (self.token.lineno, self.msg, self.token.strvalue)
        else:
            return 'Syntax error: %s' % self.msg

class FSLRuntimeError(FSLError):
    def __init__(self, msg):
        FSLError.__init__(self, msg)
