class Variable:
    def __init__(self, variable_name, variable_type):
        self.variable_name = variable_name
        self.variable_type = variable_type
        self.value = None

    def set_value(self, value):
        self.value = value

    def __str__(self):
        return 'Variable (%s, type %s)' % (self.variable_name, type2str(self.variable_type))


class SymbolTable:
    def __init__(self):
        self._stack = []

    def push(self, variable):
        self._stack.insert(0, variable)

    def pop(self):
        self._stack.pop(0)

    def get(self, symbolname):
        for variable in self._stack:
            if variable.variable_name == symbolname:
                return variable
        return None